REM ---------------------------------------------------------------------
REM
REM Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
REM                        pour la Santé)
REM Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
REM
REM  This software is governed by the CeCILL-B license under French law and 
REM  abiding by the rules of distribution of free software. You can  use, 
REM  modify and/ or redistribute the software under the terms of the CeCILL-B 
REM  license as circulated by CEA, CNRS and INRIA at the following URL 
REM  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
REM  or in the file LICENSE.txt.
REM
REM  As a counterpart to the access to the source code and  rights to copy,
REM  modify and redistribute granted by the license, users are provided only
REM  with a limited warranty  and the software's author,  the holder of the
REM  economic rights,  and the successive licensors  have only  limited
REM  liability. 
REM
REM  The fact that you are presently reading this means that you have had
REM  knowledge of the CeCILL-B license and that you accept its terms.
REM ------------------------------------------------------------------------  

REM @echo off

set creatoolsGeneration=%1
set docgeneration=%2
set buildtype=%3
set platforme=%4

set logFolder=%creatoolsGeneration%\creatools_%buildtype%%platforme%\installLog
set installPrefix=%creatoolsGeneration%\creatools_%buildtype%%platforme%\creatools_install

echo --Change ThirdParty directories (CSI/act)--
set homedir=%cd%
cd E:\creatis\CSI
call act\rename_dir.bat
rename act_%buildtype%-%platforme% act

cd %creatoolsGeneration%

mkdir creatools_%buildtype%%platforme%
mkdir creatools_%buildtype%%platforme%\Result_Installers
mkdir creatools_%buildtype%%platforme%\installLog

echo call configure variables
call %scriptsFolder%\base\configureVariables.bat

REM goto skypToEED
REM :skypToEED

echo call compile crea
start /B /wait %scriptsFolder%\crea\creaInstall.bat
echo call compile bbtk
start /B /wait %scriptsFolder%\bbtk\bbtkInstall.bat
echo call compile creaMaracasVisu
start /B /wait %scriptsFolder%\creaMaracasVisu\creaMaracasVisuInstall.bat
echo call compile creaVtk
start /B /wait %scriptsFolder%\creaVtk\creaVtkInstall.bat
echo call compile creaEnvironment
start /B /wait %scriptsFolder%\creaEnvironment\creaEnvironmentInstall.bat
echo call compile creaBruker
start /B /wait %scriptsFolder%\creaBruker\creaBrukerInstall.bat
echo call compile creaImageIO
start /B /wait %scriptsFolder%\creaImageIO\creaImageIOInstall.bat
echo call compile creaContours
start /B /wait %scriptsFolder%\creaContours\creaContoursInstall.bat
echo call compile creaRigidRegistration
start /B /wait %scriptsFolder%\creaRigidRegistration\creaRigidRInstall.bat
echo call compile bbtkGEditor
start /B /wait %scriptsFolder%\bbtkGEditor\bbtkGEditorInstall.bat
echo call compile creaMinitools
start /B /wait %scriptsFolder%\creaTools\creaMinitoolsInstall.bat



echo  THIS HAS TO BE THE LAST STEP...
echo call compile creaTools
start /B /wait %scriptsFolder%\creaTools\creaToolsInstall.bat
echo To see the log files of this install please go to %LogFolder%

