@echo off
echo -----------------------------------
echo ----------Moving Dlls--------------
echo -----------------------------------
echo -----------------------------------
echo ---Setting Enviroment Variables----
echo -----------------------------------

set thirdpartyGeneration=%1
set buildType=%2
::The following line is to force x86 or x64 compilation
set x86Comp=%3

set installpath=%thirdpartyGeneration%\thirdparty_install\%buildType%
set binpath=%thirdpartyGeneration%\thirdparty_bin\%buildType%
set sourcepath=%thirdpartyGeneration%\thirdparty_source\%buildType%

set creaThirdPartydlls=%thirdpartyGeneration%\thirdparty_temp\creaThirdParty_dlls

set qt=qt
set jom=jom
set wxWidgets=wxWidgets
set boost=boost
set xercesc=xerces
set itk=itk
set gdcm=gdcm13
set vtk=vtk
set tth=tth
set sqlite=sqlite

set QTDIR=%sourcepath%\%qt%
set WXDIR=%sourcepath%\%wxWidgets%
set BOOSTDIR=%sourcepath%\%boost%
set XERCESDIR=%sourcepath%\%xercesc%
set ITKSRCDIR=%sourcepath%\%itk%
set VTKSRCDIR=%sourcepath%\%VTK%
set GDCMSRCDIR=%sourcepath%\%gdcm%
set BOOSTINSTALLDIR=%installpath%\%boost%
set ITKINSTALLDIR=%installpath%\%itk%
set VTKINSTALLDIR=%installpath%\%vtk%
set GDCMINSTALLDIR=%installpath%\%gdcm%
set SQLITEINSTALLDIR=%installpath%\%sqlite%

rmdir /S /Q %creaThirdPartydlls%

mkdir %creaThirdPartydlls%

echo setting buildtype libraries
if %buildType%==release (
	set qtBtype=4
	set wxPrefixBase=wxbase28
	set wxPrefixmsw=wxmsw28
	set xercesFile=xerces-c_3_1.dll
) else (
	set qtBtype=d4
	set wxPrefixBase=wxbase28d
	set wxPrefixmsw=wxmsw28d
	set xercesFile=xerces-c_3_1D.dll
)


if %x86Comp%==ON (
	set vcFolder=vc_dll
	set winType=Win32
) else (
	if %PROCESSOR_ARCHITECTURE%==x86  (
		set vcFolder=vc_dll
		set winType=Win32
	) else (
		set vcFolder=vc_amd64_dll
		set winType=Win64
	)
)

echo -----------------------------------
echo Environment variables Configuration
echo -----------------------------------
echo buildType=%buildType%
echo ThirdpartyGeneration=%thirdpartyGeneration%
echo InstallPath=%installpath%
echo BinPath=%binpath%
echo SourcePath=%sourcepath%
echo creaThirdPartyLibraries=%thirdpartyInstallPath%\creaThirdParty_libraries
echo QT=%qt%
echo qtBtype=%qtBtype%
echo WX=%wxWidgets%
echo BOOST=%boost%
echo Xercesc=%xercesc%
echo ITK=%itk%
echo GDCM=%gdcm%
echo VTK=%vtk%
echo QTDIR=%QTDIR%
echo WKDIR=%WXDIR%
echo BOOSTDIR=%BOOSTDIR%
echo XERCESDIR=%XERCESDIR%
echo ITKSRCDIR=%ITKSRCDIR%
echo VTKSRCDIR=%VTKSRCDIR%
echo SQLSRCDIR=%SQLITESRCDIR%


echo -----------------------------------
echo -------------QT--------------------
echo -----------------------------------

copy /V /Y %QTDIR%\bin\phonon%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtCore%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtGui%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtNetwork%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtOpenGL%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtScript%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtScriptTools%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtSql%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtSvg%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtTest%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtXml%qtBtype%.dll %creaThirdPartydlls%
copy /V /Y %QTDIR%\bin\QtXmlPatterns%qtBtype%.dll %creaThirdPartydlls%

echo -----------------------------------
echo -------------wxWidgets-------------
echo -----------------------------------


copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixBase%_net_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixBase%_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixBase%_xml_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_adv_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_aui_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_core_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_gl_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_html_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_media_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_qa_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_richtext_vc_custom.dll %creaThirdPartydlls%
copy /V /Y %WXDIR%\lib\%vcFolder%\%wxPrefixmsw%_xrc_vc_custom.dll %creaThirdPartydlls%


echo -----------------------------------
echo -------------Boost-----------------
echo -----------------------------------

REM set boostMT=-vc100-mt-1_49.dll
REM set boostMTGD=-vc100-mt-gd-1_49.dll
set boostMT=-vc100-mt-1_52.dll
set boostMTGD=-vc100-mt-gd-1_52.dll

copy /V /Y %BOOSTINSTALLDIR%\lib\boost_date_time%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_date_time%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_filesystem%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_filesystem%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_graph%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_graph%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_iostreams%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_iostreams%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_prg_exec_monitor%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_prg_exec_monitor%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_program_options%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_program_options%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_regex%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_regex%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_serialization%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_serialization%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_signals%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_signals%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_system%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_system%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_thread%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_thread%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_unit_test_framework%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_unit_test_framework%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_wave%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_wave%boostMTGD% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_wserialization%boostMT% %creaThirdPartydlls%
copy /V /Y %BOOSTINSTALLDIR%\lib\boost_wserialization%boostMTGD% %creaThirdPartydlls%


echo -----------------------------------
echo -------------Xcerces---------------
echo -----------------------------------

copy /V /Y %XERCESDIR%\Build\%winType%\VC10\%buildType%\%xercesFile% %creaThirdPartydlls%

echo -----------------------------------
echo -------------ITK-------------------
echo -----------------------------------

copy /V /Y %ITKINSTALLDIR%\bin\*.exe %creaThirdPartydlls%
copy /V /Y %ITKINSTALLDIR%\bin\*.dll %creaThirdPartydlls%


echo -----------------------------------
echo -------------VTK-------------------
echo -----------------------------------

copy /V /Y %VTKINSTALLDIR%\bin\*.exe %creaThirdPartydlls%
copy /V /Y %VTKINSTALLDIR%\bin\*.dll %creaThirdPartydlls%

echo -----------------------------------
echo -------------GDCM------------------
echo -----------------------------------

copy /V /Y %GDCMINSTALLDIR%\bin\*.exe %creaThirdPartydlls%
copy /V /Y %GDCMINSTALLDIR%\bin\*.dll %creaThirdPartydlls%

echo -----------------------------------
echo -------------SQLite------------------
echo -----------------------------------

echo copy /V /Y %SQLITEINSTALLDIR%\bin\*.dll %creaThirdPartydlls%
copy /V /Y %SQLITEINSTALLDIR%\bin\*.dll %creaThirdPartydlls%



echo -----------------------------------
echo ------End of Moving Dlls-----------
echo -----------------------------------

exit /B