# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  


#!/bin/bash

 echo  "in ThirdParty-install-WT.sh, source " $PWD/scripts/CreaTools-configure.sh
 if [ ! -f $PWD/scripts/CreaTools-configure.sh ]
 then 
   echo
   echo "..ERROR.."
   echo "==================================================="
   echo "REMEMBER !"
   echo ""
   echo "YOU NEED TO RUN 'Configure' (0) First !"
   echo "==================================================="
   echo
   echo
   exit 0
fi

source $PWD/scripts/CreaTools-configure.sh

   echo "------"
   echo $PWD/scripts/CreaTools-configure.sh
   echo --generationdir--
   echo $generationdir
   echo --docgeneration--
   echo $docgeneration
   echo --installPrefix--
   echo $installPrefix
   echo --installPrefixThird--
   echo $installPrefixThird
   echo --buildType--
   echo $buildType
   echo --gdcmVersion--
   echo $gdcmVersion
#   echo --sourcesFrom--
#   echo $sourcesFrom
#   echo --scriptDir--
#   echo $scriptDir
#   echo --start_point--
#   echo $start_point
   echo "------"


scriptDir=$PWD
sourcesDir=$generationdir/thirdparty_sources
binDir=$generationdir/thirdparty_bin

if [ ! -e $generationdir ]
then
   mkdir -p $generationdir
   chown -R $loginUserName  $generationdir
   chgrp -R $loginGroupName $generationdir

fi
if [ ! -e $sourcesDir ]
then
   mkdir -p $sourcesDir
   #was : (pb on MacOS?)
   #chown -R $loginUserName:$loginGroupName $sourcesDir
   chown -R $loginUserName  $sourcesDir
   chgrp -R $loginGroupName $sourcesDir
fi

if [ ! -e $binDir ]
then
   mkdir -p $binDir
   chown -R $loginUserName  $binDir
   chgrp -R $loginGroupName $binDir
fi

  echo "we remove old stuff"
  rm -rf $sourcesDir/wt*
  rm -rf $sourcesDir/wt*
  rm -rf $binDir/wt*

  cd $sourcesDir

 echo "we download new stuff"
 if [ $OperatingSystem = "MacOS" ]
 then

  curl -O http://www.creatis.insa-lyon.fr/~davila/creatools_back_site/crea_ThirdParty_Libraries/source/wt-3.3.4.tar.gz
  tar -xvzf wt-3.3.4.tar.gz
  # MacOS, clever enough to understand it *has* to uncompress, doesn't understand tar -z :-(
 else
  wget http://www.creatis.insa-lyon.fr/~davila/creatools_back_site/crea_ThirdParty_Libraries/source/wt-3.3.4.tar.gz
  echo tar -xvzf wt-3.3.4.tar.gz
  pwd
  tar -xvzf wt-3.3.4.tar.gz
 fi


#if [ $buildType = "Debug" ]
#then
#   debug="ON"
#else
#   debug="OFF"
#fi

# the following stupid test is used at debug time; Please don't remove!
#if [ true = false ]
if [ true = true ]
then
  libname=wt-3.3.4
  dirInstall=$binDir/$libname-Bin
##  export VTK_DIR=$installPrefixThird/lib/vtk-5.6/
  export WT_DIR=$installPrefixThird/lib/wt-3.3.4/

  mkdir -p $dirInstall
  echo "we prepare directories dirInstall " $dirInstall  " WT_DIR " $installPrefixThird/lib/wt-3.3.4/
  cd $dirInstall

# See EED why we have to do this
  if [ $OperatingSystem = "MacOS" ]
  then
     cmake -D  CMAKE_CXX_COMPILER:FILE=/usr/bin/g++
  fi
  cmake -G"Unix Makefiles" -H$sourcesDir/$libname -B$dirInstall/
  ##cmake -G"CodeBlocks - Unix Makefiles" -H$sourcesDir/$libname -B$dirInstall/
  cmake -D CMAKE_BUILD_TYPE:STRING=$buildType -D CMAKE_INSTALL_PREFIX:PATH=$installPrefixThird CMakeCache.txt
  cmake -D LIB_INSTALL_DIR:PATH=lib/$libname -D ENABLE_EXT:BOOL=true ENABLE_MYSQL:BOOL=false CMakeCache.txt
  cmake -D BUILD_TESTS:BOOL=false CMakeCache.txt
#  if [ $OperatingSystem = "MacOS" ]
#  then
#     ###
#  fi

  make -j $corenumber
  su -c 'make install'
  cd ..
fi
